// =====================================================================
/*!
//
//  \file TDataRecord.hh
//  \brief This file contains the TDataRecord class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TDataRecord.hh,v 1.10 2004/03/07 10:30:30 goiwai Exp $
//  $Name: CLDAQ-1-14-06 $
//  $Log: TDataRecord.hh,v $
//  Revision 1.10  2004/03/07 10:30:30  goiwai
//  ROOTに組みこむためのおまじないマクロを埋めこみました。
//  全てにおいて完全に動作するわけではありません。
//
//  Revision 1.9  2004/01/19 21:09:39  goiwai
//  プリプロセッサの接頭辞をCLDAQ__に変更しました.
//
//  Revision 1.8  2003/12/06 10:59:11  goiwai
//  Serialize(Tvoid*) -> Serialize(const Tvoid*)に変更しました.
//  Deserialize(const Tvoid*)を追加しました.
//  手抜きの実装なので,バッファオーバーフローの可能性があります.
//  Reallocate()とかするような仕組みが必要です.
//
//  Revision 1.7  2003/11/24 06:54:54  goiwai
//  Size()メンバ関数を追加しました.
//  抱えているDataSectionの数を返します.
//
//  Revision 1.6  2003/11/04 12:03:05  goiwai
//  ==演算子と!=演算子を実装しました.具体的には
//  if ( record == "String" ) {
//    hoeghoge;
//  }
//  のような使い方が出来ます.単純に theID メンバとを比較して結果を返します.
//
//  Revision 1.5  2003/11/03 08:35:12  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.4  2003/10/06 16:42:08  goiwai
//  テスト用の関数としてTest()を加えました.適当なデータレコードを発生しま
//  す.
//
//  Revision 1.3  2003/08/25 09:19:37  goiwai
//  operator[]( const Tstring& id ) を加えました.
//  record[0] とか record["tag"] とかすれば,TDataSection を得ることが出来
//  ます.
//  size()を越えた範囲にも,チェックしないでアクセスします.
//  マッチしなかった場合は落ちます.
//  同じ名前でタグされた DataSection がある場合,最初にマッチしたものが返っ
//  てきます.
//
//  Revision 1.2  2003/07/30 16:17:51  goiwai
//  ファイルにコミットログをつけることにしました.
//
*/
// =====================================================================
#ifndef CLDAQ__TDATARECORD_HH
#define CLDAQ__TDATARECORD_HH

#include "Tglobals.h"
#include "TStreamableObject.hh"
#include "TDataSectionList.hh"

class TOutputObjectStream;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TDataRecord
// \brief This is the TDataRecord class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TDataRecord class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup DatarecordCategory
*/
class TDataRecord
  : public TStreamableObject, public TDataSectionList
{

  public:
    TDataRecord( const Tstring& id = TunknownID );
    TDataRecord( const TDataRecord& right );
    ~TDataRecord();

  public:
    Tint GetRecordSize();
    Tint Record( TOutputObjectStream* output );
    Tvoid Clear();
    Tint Serialize( const Tvoid* buffer );
    Tint Deserialize( const Tvoid* buffer );
    Tint Size() const;

  public:
    const TDataRecord& operator=( const TDataRecord& right );
    Tbool operator==( const TDataRecord& right ) const;
    Tbool operator!=( const TDataRecord& right ) const;
    Tbool operator==( const Tstring& right ) const;
    Tbool operator!=( const Tstring& right ) const;
    //operator[]( const Tstring& secid )を加えたかったら
    //reference operator [](size_type n);
    //const_reference operator [](size_type n) const;
    //TDataSection& operator[]( Tsize_t n );も
    //実装しなくちゃだめみたい.めんどくさいな〜
    const TDataSection& operator[]( Tint n ) const;
    TDataSection& operator[]( Tint n );
    const TDataSection& operator[]( const Tstring& id ) const;
    TDataSection& operator[]( const Tstring& id );
    friend Tostream& operator<<( Tostream& tos, const TDataRecord& right );

  public:
    TDataRecord Test( Tint somevalue = 0 );

  public:
    Tbool FindDataSection( const Tstring& id, TDataSection& section ) const;
    Tint FindDataSection( const Tstring& id ) const;
    Tbool FindDataSegment( const Tstring& secid, const Tstring& segid, TDataSegment& segment ) const;
    Tint FindDataSegment( const Tstring& secid, const Tstring& segid ) const;
    Tbool FindDataSegment( Tstring idset[ 2 ], TDataSegment& segment ) const;
    Tint FindDataSegment( Tstring idset[ 2 ] ) const;
    Tbool FindDataSegment( const TstringList& idset, TDataSegment& segment ) const;
    Tint FindDataSegment( const TstringList& idset ) const;
    Tbool FindDataElement( const Tstring& secid, const Tstring& segid, const Tstring& eleid, TDataElement& element ) const;
    Tint FindDataElement( const Tstring& secid, const Tstring& segid, const Tstring& eleid ) const;
    Tbool FindDataElement( Tstring idset[ 3 ], TDataElement& element ) const;
    Tint FindDataElement( Tstring idset[ 3 ] ) const;
    Tbool FindDataElement( const TstringList& idset, TDataElement& element ) const;
    Tint FindDataElement( const TstringList& idset ) const;

  private:
    Tint record( TOutputObjectFile* ofile );
    Tint record( TOutputObjectSocket* osocket );
    Tint record( TOutputObjectSharedMemory* omemory );

#ifdef __CLDAQ_ROOT_DLL
    ClassDef(TDataRecord,0)
#endif

};

inline Tint TDataRecord::Size() const
{
  return (Tint)size();
}

#endif
